Index: Singular/cntrlc.cc
===================================================================
--- Singular/cntrlc.cc	(revision dcb1b7234585e33f2aa5d87adfdbc154c0cd591e)
+++ Singular/cntrlc.cc	(revision 48ce9a6586315bf81f1feb56a74edfe29d400294)
@@ -2,5 +2,5 @@
 *  Computer Algebra System SINGULAR     *
 ****************************************/
-/* $Id: cntrlc.cc,v 1.48 2005-05-06 14:21:19 Singular Exp $ */
+/* $Id: cntrlc.cc,v 1.49 2005-07-27 09:59:26 Singular Exp $ */
 /*
 * ABSTRACT - interupt handling
@@ -495,39 +495,7 @@
 #endif /* !MSDOS */
 
-//#ifdef macintosh
-//#include <Types.h>
-//#include <Events.h>
-//#include <OSEvents.h>
-//#include <CursorCtl.h>
-//
-///*3
-//* macintosh only:
-//* side effect of ^C is to insert EOF at the end of the current
-//* input selection. We must drain input, reach this EOF, then clear it
-//*/
-//static void flush_intr(void)
-//{
-//  int c;
-//
-//  while ((c=getchar())!=EOF);
-//  clearerr(stdin);
-//}
-//
-///*3
-//* macintosh only:
-//* spin beach ball in MPW, allows MPW-tool to go to the background
-//* so you can use the finder and interrupts
-//*/
-//static void beachball(void)
-//{
-//  Show_Cursor(HIDDEN_CURSOR);
-//  SpinCursor(10);
-//}
-//#endif
-
 #ifndef MSDOS
 //void test_int()
 //{
-//#ifndef macintosh
 //  if (siCntrlc!=0)
 //  {
@@ -535,11 +503,7 @@
 //    siCntrlc = FALSE;
 //    si_set_signal(SIGINT ,sigint_handler);
-////#ifdef macintosh
-////    flush_intr();
-////#endif
 //    iiDebug();
 //    si_echo = saveecho;
 //  }
-//#endif
 //}
 #endif /* !MSDOS */
Index: Singular/iplib.cc
===================================================================
--- Singular/iplib.cc	(revision dcb1b7234585e33f2aa5d87adfdbc154c0cd591e)
+++ Singular/iplib.cc	(revision 48ce9a6586315bf81f1feb56a74edfe29d400294)
@@ -2,5 +2,5 @@
 *  Computer Algebra System SINGULAR     *
 ****************************************/
-/* $Id: iplib.cc,v 1.115 2005-05-23 15:28:15 Singular Exp $ */
+/* $Id: iplib.cc,v 1.116 2005-07-27 09:59:26 Singular Exp $ */
 /*
 * ABSTRACT: interpreter: LIB and help
@@ -1150,6 +1150,4 @@
 //#if defined(WINNT)
 //#  define  FS_SEP '\\'
-//#elif defined(macintosh)
-//#  define FS_SEP ','
 //#else
 //#  define FS_SEP '/'
Index: Singular/misc.cc
===================================================================
--- Singular/misc.cc	(revision dcb1b7234585e33f2aa5d87adfdbc154c0cd591e)
+++ Singular/misc.cc	(revision 48ce9a6586315bf81f1feb56a74edfe29d400294)
@@ -95,5 +95,4 @@
 *
 *#ifndef MSDOS
-*#ifndef macintosh
 *#include <sys/times.h>
 *#include <sys/resource.h>
@@ -106,7 +105,4 @@
 *  sleep(10);
 *}
-*#else
-*void very_nice(){}
-*#endif
 *#else
 *void very_nice(){}
Index: Singular/mod2.h.in
===================================================================
--- Singular/mod2.h.in	(revision dcb1b7234585e33f2aa5d87adfdbc154c0cd591e)
+++ Singular/mod2.h.in	(revision 48ce9a6586315bf81f1feb56a74edfe29d400294)
@@ -6,5 +6,5 @@
  *          DO NOT EDIT!
  *
- *  Version: $Id: mod2.h.in,v 1.111 2005-07-26 17:06:58 Singular Exp $
+ *  Version: $Id: mod2.h.in,v 1.112 2005-07-27 09:59:27 Singular Exp $
  *******************************************************************/
 #ifndef MOD2_H
@@ -216,5 +216,5 @@
 /* Undefine to disable real time measurments  */
 #ifdef HAVE_GETTIMEOFDAY
-#if ! defined(__MWERKS__) && ! defined(MSDOS)
+#if ! defined(MSDOS)
 #define HAVE_RTIMER
 #else
Index: Singular/mpsr_Tok.cc
===================================================================
--- Singular/mpsr_Tok.cc	(revision dcb1b7234585e33f2aa5d87adfdbc154c0cd591e)
+++ Singular/mpsr_Tok.cc	(revision 48ce9a6586315bf81f1feb56a74edfe29d400294)
@@ -3,5 +3,5 @@
 ****************************************/
 
-/* $Id: mpsr_Tok.cc,v 1.30 2001-08-27 14:47:17 Singular Exp $ */
+/* $Id: mpsr_Tok.cc,v 1.31 2005-07-27 09:59:27 Singular Exp $ */
 
 /***************************************************************
@@ -580,5 +580,5 @@
 
 // simply touch mpsr_Tok.inc so that Make does not get confused
-#if !defined(macintosh) && !defined(HPUX_9)
+#if !defined(HPUX_9)
 extern "C" int system(char *);
 #else
@@ -588,13 +588,7 @@
 void mpsr_ttGen()
 {
-#ifndef macintosh
   system("touch mpsr_Tok.inc");
-#else
-  // simulate touch on a macintosh
-  FILE *fd = fopen("mpsr_Tok.inc", "w");
-  close(fd);
+}
 #endif
-}
-#endif
 
 #endif // HAVE_MPSR
Index: Singular/ndbm.cc
===================================================================
--- Singular/ndbm.cc	(revision dcb1b7234585e33f2aa5d87adfdbc154c0cd591e)
+++ Singular/ndbm.cc	(revision 48ce9a6586315bf81f1feb56a74edfe29d400294)
@@ -5,5 +5,5 @@
 //**************************************************************************/
 //
-// $Id: ndbm.cc,v 1.15 2005-07-26 17:06:58 Singular Exp $
+// $Id: ndbm.cc,v 1.16 2005-07-27 09:59:27 Singular Exp $
 //
 //**************************************************************************/
@@ -33,20 +33,18 @@
 
 #include <stdio.h>
-#ifdef __MWERKS__
-#   define bcopy(a,b,c) memmove(b,a,c)
-#   define EPERM 1
-#   define ENOMEM 23
-#   define ENOSPC 28
-#   define L_SET SEEK_SET
-#else
-#   include <sys/types.h>
-#   include <sys/stat.h>
-#   include <sys/file.h>
-#   include <errno.h>
-#   include <stdlib.h>
-#   include <string.h>
-#   include <unistd.h>
-#   include <fcntl.h>
-#endif
+/* alternative:
+* #   define EPERM 1
+* #   define ENOMEM 23
+* #   define ENOSPC 28
+* #   define L_SET SEEK_SET
+*/
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <sys/file.h>
+#include <errno.h>
+#include <stdlib.h>
+#include <string.h>
+#include <unistd.h>
+#include <fcntl.h>
 #ifndef HAVE_BCOPY
 #   define bcopy(a,b,c) memmove(b,a,c)
@@ -78,10 +76,4 @@
     return ((DBM *)0);
   }
-#ifdef macintosh
-  // It seems that the compile has some problems to commit the flags properly
-  // O_RDWR | O_CREAT = 0x102 change to 0x200. We don't know why.
-  // setting flags to O_RDWR | O_CREAT solved our problem. :-(
-  flags = O_RDWR | O_CREAT;
-#endif /* macintosh */
 #ifdef MSDOS
   // default mode of open is ascii, we need binary mode.
Index: Singular/tesths.cc
===================================================================
--- Singular/tesths.cc	(revision dcb1b7234585e33f2aa5d87adfdbc154c0cd591e)
+++ Singular/tesths.cc	(revision 48ce9a6586315bf81f1feb56a74edfe29d400294)
@@ -2,5 +2,5 @@
 *  Computer Algebra System SINGULAR     *
 ****************************************/
-/* $Id: tesths.cc,v 1.99 2005-07-26 17:06:58 Singular Exp $ */
+/* $Id: tesths.cc,v 1.100 2005-07-27 09:59:27 Singular Exp $ */
 
 /*
@@ -150,9 +150,8 @@
     sdb_flags = 0;
 #endif
-#ifdef __MWERKS__
-    memcpy(stderr,stdout,sizeof(FILE));
-#else
     dup2(1,2);
-#endif
+    /* alternative:
+    *    memcpy(stderr,stdout,sizeof(FILE));
+    */
   }
   slStandardInit();