Index: Tst/Short/deform_s.res.gz.uu
===================================================================
--- Tst/Short/deform_s.res.gz.uu	(revision 7bb006de4b4b9f13dbe2e1196b0c5e4a5b5fd2c5)
+++ Tst/Short/deform_s.res.gz.uu	(revision 55caed7e7785f2cb4156ccb572a0c6cee02d66d5)
@@ -1,67 +1,66 @@
-begin 640 deform_s.res.gz
-M'XL(""KBG$4``V1E9F]R;5]S+G)E<P#M6FMOV[@2_:Y?0107B!U1CD4I3IM<
-M!9#\:!,D11[]<($@#1Q;:71C6UD]',F+_>]W9BA+M.*\BNUB<3?>K2T-#X?#
-M&<X<DNWYM][!5\:8N<^VML;^31A-K^)6$B?:>=$B6M`2WX91PA(_3F(&&":1
-MK4EP7>(LQ!E/?TJ@W6)'!Q[[`(.@@@][9<OV/@/A53`+DD9S3\-?MK_/2K-F
-M_D,K3H:5;9U]J:HR1]&VL\_\;#B]G_AL[D?Q<+*G;6VQ^R@<%>_L)@JG##JI
-MT^G_QST^.>KO:J`AF"7LGI4?!SJ#:.+/?=`%@NJU:&^3&*0_6&16W=J\D?&<
-M+WC*YTT^C@DU'291D+'IA;B\L"\!M8040`(%8Q_L'(2EJFDP"Z/&E(LFM3_Z
-MP`Q'X<QG(4R11<,D"&>@`/I,X6>41G-HNH'Y_HA\G]FH8A+$"3MRI$L:@[!)
-M;MK<9(<LB*$G`X_/QL-HS*Z'<1!CEZ,][<*\)!<!E+'1[3`:CA(_`E7!B.VR
-MMD;R63J]!C-@P/DPBD'^2<KI<ST)1W>X\D`>1F.?O#:.%43UV66SX=2/\=%E
-M'NNR'ENC2;Q-4\9RMF`IFZ_39:FZNAH$Z9\T70#\EH9)X$,"D(@R12[&5JNE
-M75@_XP[[KW,'1,Q^CY@2,>@!18Z=9,X1I"[5CMA/"'F2[16.NKJZ8OW?4JH:
-M,7H%JDU0U$I(?I_%]\.1CS!R[6&\]P'J[6%\87+STO%Z\E%<.F[/Z`GY9ETZ
-M1K>GO6*$)$S@>W6(@1QB4`QAI$)?S'4OU7MS*83!C$6JYW/#!6$JA3AFGNK9
-M7.^"<"&%]J6S$"AV%[J72]GVI9,OC"S5O<SH%K@.=A9ZMM#=3._FFE82RD?D
-M2!8!":+E#[?#A*6Q/P;#V;4/9,$2%!6<4_;ZU,*P22I999`"8;;W$4&Q8)$H
-MXERQAF2,)=@D\"->R`3/<IXO^"*KL(*PCUA*5`B+$+@R'C'`.)BR;U<FX+>K
-M5P&OE,:1/QSGNP0`=L`6E.(KD`8$.`Z,VW`:_O!G?IC&`+\'O\'B!'<]!,DM
-M>_"#'[>),?='21AI;5[\ATJ"V0TROQ\'R%F2FFG![,)RV&5:)O1N!K.%H$%\
-M]#Y.&V/5RSD$#<((.H"S8+\R"J?W:4)],3P%ZXD6(F9^!K$JEB+&LUK@NYK;
-MYUH/_AC=OM$7\.OUGR=%:$2CXUM_K+TID7`H&*D8J!CG#5GRV!NZURT=HGN]
-MPB<:ZMV0.C8@'$D:S2`60Z)_SN)ASHXX#G43IA&MQ;C%#F8,JP4;1F`QQ,D?
-M[\I*-(R7VQ>,R(JIJGWX>NNKUBO1Y'55AW55:YWVJ-L9=(OS1?XC\*G7`%K"
-M,6BC,'\+V7`T\N,8+0$=XV$RY"S)[WVY?5*+HEH19=8T!G%S^7A8/9[!(SGT
-M"/8%D!'8>PN2$9:4/QNCAM/0.0E!Q"7*0A2ZP@>^&1."!BH<M'Z21W);2,H/
-M8T4YZMO"^95I;._7YX+/YZ&#T"K;MPE6S+)QCHF^;.HH9>4P=B#U[ALG&<=)
-MEY@=PMP&D^M&G(S1(>`1E<1,EGQO*P+#!H%0$1T06'6$7=>QK3VGE02FJL2J
-M#V/5AS&7PT`9\V<QIGP#B'0X:5)%I*9I.DF"^TDP"I(<9&8Y[X_KR^A]Y9E/
-MA+@+)A/((G#;>5BVB79U#(%U>54_BE2REXXCZRADQ2RP&2622,["DD*:_.&^
-M87&;C@PRQ`?8FMEZ;J&LR*3C$,\BM**!3G(.-,@S@0!Y1L#C1VEMXSCD!P55
-MS)$<&OT,HM!<>K.2F<T::8!0L@8\B*I:0WE&<JH+K+K`K@OD<MFH;'M;@1//
-M%KAC*"\%=TFJ*.1%ZLI0P4`P>CIY7)V.H/LDN$'>6Q:IM87OV2*ZOH"^MKR=
-M8DD02GD[+<O;<573CE8K'6[8GNJ\7'74'0C(<#/#TUUA=*W,L+JBI[M=B^?`
-M2WH/N#-'ALJ!C8RN`+#H]C+8'<+*0H[R2F5H`("-+K1R5OL4X)K\Z;'A/<L-
-M($`<4L<A==B0,G6"AG"AHZ5;W9XPO*YE6"YU%]`?"!\&%)[>`[%'8D`4H\-N
-MI6Z>8E+[Z3963]=[2L@;U@!/![!:H>(VF^QWJB-014ZID/Q1EGEA5J4$U]15
-MY$^N[JZK6J((7RHF\H["@0+A<H]3D1B3.7(=LV-65+D+VEE>\@O<7EKPFPOX
-M:O/L4D'?(74=(]I$)*$12DB3ON4S=*;E$TYR=N-DN:+C*W9W/>YY"'4M6#*9
-MS5UOLV'JN6A>*H7*!:@RU\97?LRE"?RF62U/%YY!(80+0U;\N!!=Y<WCFB=X
-M^88A^O"M?_YM%TX=]%MJDV,WY#C-3=<H!%`TTI$/-B`G'C?ALT?[6?QB5>S$
-MSQP>A(6'AP\":Z6,'9BEO)4XV@#(PL\B)(+VLO2/*YH2Q/^2`-@!57F=2GQ>
-M06@?4*X!A_UW.`JO&P=-_6#S!C;/LJ4AJEV!V%%Z4`PS/>>F#KIA#50P(M&G
-MXZ<H)#*M(FB8%+"5/R;D4@&WVA6<8M,HXK!)G7.^`C8K\*.X/4:+6KZ1_EJZ
-MD>Q5V7;FE#&)U4QSRA3+BU_(KDRF2ZYFV5=`6N!53@G&P<]%-LEB3+48,HS3
-M\M80!_^C1$U49\5)5?>[:WC)Y2D2ZH%9G,B*7)$OU%!6L<97'!&RU`(Q%F,J
-MBVB5DJE.Y:0BS&IL:02S2!;\,LLG:C"++%KJ>Q0T/HO"AQB-Y[-1.(E!:Y,9
-M3,W5Y51A0>QI5_(>H4T/0CZ(I41(21E^J[[O<V!U[E7+`Y*N.+2;J[>\*UEG
-M8=;)I`LL3#H\IO(LQ<-ZGO)%NK=DAV4'S,'56]G`JI_)/ZZ>R3N_\$S^AI,Y
-MG<![.#O=Q0GJ_87^&194BE<V7\`W*=[(#/Z,(SI0MM[MZ]YG(&L@<CJMNR#J
-M&3T2#?3>0'>_()4/]/[`Z./CX+/1_:)__O*K#O.5485-E4F5195!*_:\Z=`/
-M>YN^]+4.NLG=J/H9C[]?`/P?7P!82,(K,UEW_K>0@]5;WZ7\4U%PYL,(MZ!4
-M:DZR-1O8B_8E8YO8'R%G\5.0(C(=ELE"-7@):0*2:MCAZY"%Y3:2?QPL_"4Q
-M#.+-LYC(@2HNW5$TR[_1NEJ?[^U2G:DX2#G#VV+_A;L1&[GB+3<CG?J5Q<?Z
-ME85%5Q;/7H18RXN0];<:VVMN->S28MPRKKVQL+>7O,9.U$L$A=-LH*CE/A(A
-M..GLNZWGWRW%)[`HRYN%2DJWZ([Z8=$=S,UYU:=4\ZE5[FF80T<.9;>Y#>NB
-M:)TVVDWGKFHQE1:S"3WI9$)7'4JJ;`L%)A!F53@%!F'':YE@HQ*!7_%OR!O!
-MAM/>"S;^;<&7$VSH9K.$;+?8[^5+![?XQZ$SA1Z5\[8_HKC8!:RY=2E@G7:K
-M7L-63NUJ&2@W&!V!G=84@HZ]'+2L!,N6CM)EY>:P0X:N)L?I:G+LD)'U[%@V
-MJL8T3A3-.V1-M41/5U;I#ECTQYK+)THJ=S9#"0@"I(D,]RMK+J7$<Y=2)'AI
-MX[3++&X_WAI1J<9\U#+=Y;GNK;WE>G9_TUY[#_9L%V_]5=D+?0S75G<\RBY,
-ML^5?*];G+_>)ZQA:@\.US=ZOXW[!==SK*/E)OC&)7MYTK4X"\32]F&OHQ?H;
-M9*3-K6<STO#P9EMWX;"?0W;"D=K+!/M+,M3]B0QU+</[$S/4YIKUGJ'O&?IW
-MSE#*R)4DA>E`WN*4W_/T/4__&7FZW.CNR'\5B__P-8WAS++W+^U_=]2!Y+8K
-"````
+begin 664 deform_s.res.gz
+M'XL("#FB(U$``V1E9F]R;5]S+G)E<P#M6FUOVT@._JY?,2@.B!V-7&ND.&U\
+M"B#YI4V0%'GIAP,"-W!LI='%MKQZ<20O]K\?R9&EL>,D3;%=W-W&N[4E#H?#
+M(8=\.&POOW:/OC#&S$/V_OW8OPVCZ77<2.)$NRQ&1`-&XKLP2ECBQTG,@(=)
+MSL8DN"GY+.0SGOZ4C':#G1QY[!TL@@+>M<N1O4,&Q.M@%B2U>EO#7W9XR$JU
+M9OY#(TZ&E6ZM0RFJ4D>1MG_(_&PXG4]\MO"C>#AI:^_?LWD4CHIW=AN%4P:3
+MU.WT_N6>GIWT#C20$,P2-F?EQX')0)KX"Q]D`:%Z+<:;1`;J=Q:9U;0FKV4\
+MYTN>\D6=CV/BF@Z3*,C8]$H,KNP!<*U8"D9B"L8^Z-D/2U'38!9&M2D7=1I_
+M]($=CL*9ST+8(HN&21#.0`#,F<+/*(T6,'0+^_T>^3ZS4<0DB!-VXDB3U/IA
+MG<RTN\N.61##3`86GXV'T9C=#.,@QBDG;>W*')")@)6QT=TP&HX2/P)1P8@=
+ML*9&]%DZO0$U8,'%,(J!_E'2Z7,S"4?W>/*`'D9CGZPVCA6.ZG/`9L.I'^.C
+MRSS68=TM@L3K!&4L9TN6LL46498JJJ.!B_X^FP6&W](P"7PX_$2B*)$'L=%H
+M:%?6SQC#_LN,`>ZRW]Q5N@MF0'9C9YES`C%+22/V$^(\R]J%F:ZOKUGOMY32
+M18PV@303%$D2HMYG\7PX\I&-#'L<M]]!HCV.KTQN#ARO*Q_%P'&[1E?(-VO@
+M&)VN]@,K)&$"W^M+].42_6()(Q7Z<J%[J=Y=2"(L9BQ3/5\8+A!32<0U\U3/
+M%GH'B$M)M`?.4B#97>I>+FE[`R=?&EFJ>YG1*?A:.%GHV5)W,[V3:UJ))!\0
+M'%D$Z(>:/]P-$Y;&_A@49S<^H`1+D%2`33GK8P/=)C%D'3H*#K-YB!SD"Q:)
+MPL\57$BH6#&;Q/P($#+!LYSG2[[,*EY!O(_@250<%G'@R7B4^L?!E'V]-H%_
+MKWH5\$HQ'/G#<7Y`#``+.()4?`6T``?'@7$73L/O_LP/TQC8YV`W.)Q@KH<@
+MN6,/?O#]+C$6_B@)(ZW)B_]02#"[1<CWXP#!2F(R'9@#.`X'3,N$WLE@M^`T
+M\(_>PVVCK[HY!Z>!&T$&@!44*J-P.D\3FHON*>!.-)!CYF?@J^(HHC^K`WZ@
+MN3VN=>&/T>D9/0&_7N]Y-(1!5#J^\\?:JP()EX*5BH6*=5X1)8^MH7N=TB"Z
+MURULHJ'<'2EC!]R1I-$,?#$DW.<L'N;LA.-2MV$:T5F,&^QHQC!;L&$$&H.?
+M_/&!S$3#>%6WH$?65%7UP]<[7]5>\2;?%'6\*6JKT1Y-NX!I<;[,OP<^S>K#
+M2#@&:>3FKR$;CD9^'*,F(&,\3(:<)?G<EW63FA35C"BCIM:/ZZO'X^KQ`A[)
+MH"=0$D!$X.SW$(QPI/S9&"6<A\Y9""0NN2SD0E/X@#9CXJ"%"@-MW^2)K`=)
+M^'&L"$=Y[W%_91C;AYM[P>?+T$'6*MKWB*W89>T2`WTUU%+2RG'L0.C-:V<9
+MQTV7//O$<Q=,;FIQ,D:#@$54##-9\JVI$`P;"$+E:`'!VN2P-V7L:<]))8*I
+M"K$VE[$VES%7RT`:\V<QAGP-@'0XJ5-&I*%I.DF"^208!4D.-+/<]X?M:71>
+M6>8C<=P'DPE$$9CM,BS'1+.Z?\"YO-Z\@U2TE^XAVR!D32W0&2D22"["$D+J
+M_&%>L[A-=P7IXB,<S6P]MY!61-)IB)<0.M$`)SD'&.290`9Y.<![1ZEM[33D
+M1P54+!`<:KT,O%!?6;.BF?4-T`"B1`UX$%6VAO2,X+1)L#8)]B9!'I>=2K?7
+M)3CQ;(([A?128)>$BH)>A*YT%2P$JZ>3Q]GI!*9/@EO$O562VIKXGDVBVQ/H
+MCZ:W<TP)0DEOYV5Z.ZURVLEZIL."[:G)JU-'TP&`##<S/-T51L?*#*LCNKK;
+ML7@.N*1W`3MS1*@<T,CH"&`6G6X&U2&<+,0HKQ2&"@"ST8%1SC8^!?,&_>FU
+MX3W+#0!`7%+')74H2)FZ04.X,-'2K4Y7&%[',BR7I@N8#X`/"PI/[P+9(S)P
+M%*M#M;*IGJ)2\^DQMAFN<PK(6U8#2P=P6B'CUNOL=\HCD$7.*9'\4:9Y85:I
+M!,_4=>1/KN]OJERB$%]*)K(YX4""<+G'*4F,21UYCMDI*[+<%566`WZ%Y:4%
+MO[F`KR;/!@KW/4+7*7*;R$G<R$J<)GW+9YA,QR><Y.S6R7)%QA><[GK<\Y#5
+MM>#(9#9WO=V:J>>B/E`2E0NLREYK7_@IERKPVWIU/%UX!H'@+G19\>."=Y4W
+MCVN>X.4;NNC=U][EUP.X==!O*4VN79/KU'==HR!`TDA'/NB`F'A:AT^;ZEG\
+M8I7OQ,]<'H2%EX=W`G.E]!VHI;R5?%0`R,3/(@2"YBKUCRN8$H3_$@#8$65Y
+MG5)\7K%0'5">`8?]>S@*;VI'=?UH]Q:*9SE2$U55(/:5&>3#3,^YJ8-L.`,5
+M&X'HT_Y3!!*85AXT3'+8VA\38JE@MYH5._FF5OAAER;G?(W9K)@?^>TQM]B(
+M-Y*_$6Y$^Z%HNW!*G\1JI#EEB.7%+T17)L,E5Z/L"W!:8%5.`<;!SD4TR61,
+MN1@BC-/QUI`/_D>*&JC.FI&JZ?<W\)++6R3D`[.XD16Q(E]HH,QBM2^X(D2I
+M!61,QI0642LE4IW*2(6;5=_2"F81+/AEED\T8!91M)+WR&E\%H4/,2K/9Z-P
+M$H/4.C.8&JNKK<*!:&O7LH_0I`<A'\2*(B2E=+^U6?<Y<#K;U?&`H"LN[>9Z
+M>W<MZBR,.AET@85!A]=4GJ5X6<]3ODS;*W183<`87&_'!M;FG?S#^IV\]0OO
+MY*^XF=,-O(N[TUW<H-Y;ZI_@0*78LOD,MDFQ(]/_,Z[H`-EZIZ=[GP"L`<CI
+MMNX"J6MTB=37NWW=_8Q0WM=[?:.'C_U/1N>S_NGSK[K,5TH5.E4J51I5"JWI
+M\ZI+/]0V/6EK'623N5'T,Q9_:P#\'S<`+`3AM9ULN_];B,%JUW=%_U@DG,4P
+MPA*44LU9]DPAR]A5<\#8+DI"YHOX9>;"6RV6R>35__$Y)LRA#'?\VCG%#FTL
+M$N)@Z:\`I!_O7L0$(I29J9=!A5LYPU1LI5SG;7'X0IO$1MAX39.DM=F]^+#9
+MO;"H>_%L3\1:]42V-SCVMC0X[%)CK!ZW-B_LO17$L3.UGZ#`FPUHM2HID04W
+MG7VS]?R;I=@$SF?99*BHU%!WU`^+[F%OS@]]2C$?&V5YPQRZ?2B%YQZXOAB=
+MUIIUY[X:,941LPXSZ9)"70\E:O:$PB:0S:KX%#9P.W9H@IV*!';%OR6O!3M.
+MLQWL_-."+R?8T<UZR;+78+^7+RVL]D]#9PHS*N/M?4!R41!L:<`4;*TFLCU*
+M`N4%7LT(9:W1$CAI2TYHV:M%RZ2P&FDI4]::B"U2=#TXSM>#8Y^4W(R.U:"J
+M3.U,D;Q/VE1']'SME.Z#1G]LZ4-14+FS&5*`$"!B9%BZ;.E/B>?Z4T1XJ88Z
+M8!:W'U=)E+4Q'K5,=WFN>UL;7L^6.LVM+;%GIWC;NV8OS#%<6RU^E(),L^7?
+M,&[N7Y:,V\!:@WNVS=XZ<[^@,_=:='X2>4P"FE?UVHD@G@8:<PO06/\%L6ES
+MZ]G8-#QL=^MNSK4<XA3NV5XFV%\2J^Y/Q*IK&=Z?&*LVUZRW6'V+U?^-6*78
+L7`M7V`Y$,&[Y+6+?(O;O%K&K,GA?_KM9_*>Q:0PWFO8_M/\`E&1$G-@K````
 `
 end
Index: Tst/Short/deform_s.stat
===================================================================
--- Tst/Short/deform_s.stat	(revision 7bb006de4b4b9f13dbe2e1196b0c5e4a5b5fd2c5)
+++ Tst/Short/deform_s.stat	(revision 55caed7e7785f2cb4156ccb572a0c6cee02d66d5)
@@ -1,4 +1,4 @@
-1 >> tst_memory_0 :: 1167909418:2007010409:3-0-3:ix86-Linux:nepomuck:850880 1292524760:3120- 13145 :3-1-2:ix86-Linux:mamawutz:293300
-1 >> tst_memory_1 :: 1167909418:2007010409:3-0-3:ix86-Linux:nepomuck:1363804 1292524760:3120- 13145 :3-1-2:ix86-Linux:mamawutz:745472
-1 >> tst_memory_2 :: 1167909418:2007010409:3-0-3:ix86-Linux:nepomuck:1363804 1292524760:3120- 13145 :3-1-2:ix86-Linux:mamawutz:794624
-1 >> tst_timer_1 :: 1167909418:2007010409:3-0-3:ix86-Linux:nepomuck:70 1292524760:3120- 13145 :3-1-2:ix86-Linux:mamawutz:34
+1 >> tst_memory_0 :: 1361289785:3160:3-1-6:ix86-Linux:lubuntu:270696
+1 >> tst_memory_1 :: 1361289785:3160:3-1-6:ix86-Linux:lubuntu:2293760
+1 >> tst_memory_2 :: 1361289785:3160:3-1-6:ix86-Linux:lubuntu:2342912
+1 >> tst_timer_1 :: 1361289785:3160:3-1-6:ix86-Linux:lubuntu:9