Index: Singular/LIB/help.cnf
===================================================================
--- Singular/LIB/help.cnf	(revision 351717f210df19b5dd8d203ad7fc30592d9516c6)
+++ Singular/LIB/help.cnf	(revision 57aada1852e42727c6b0903d65418eddb4abee45)
@@ -25,5 +25,5 @@
 # the default help browsers builtin, dummy and emacs are always 
 #   available and should NOT be mentioned here
-# ix86_Win: has additional default browsers: htmlhelp, html and winhlp
+# __CYGWIN__: has additional default browsers: htmlhelp, html and winhlp
 #   also not mentioned here
 #----------------------------------------------------
Index: Singular/sing_win.cc
===================================================================
--- Singular/sing_win.cc	(revision 351717f210df19b5dd8d203ad7fc30592d9516c6)
+++ Singular/sing_win.cc	(revision 57aada1852e42727c6b0903d65418eddb4abee45)
@@ -11,5 +11,5 @@
 
 #include <kernel/mod2.h>
-#ifdef ix86_Win
+#ifdef __CYGWIN__
 #include <windows.h>
 #include <winuser.h>
@@ -110,3 +110,3 @@
 }
 
-#endif /*ix86_Win */
+#endif /*__CYGWIN__ */
Index: Singular/sing_win.h
===================================================================
--- Singular/sing_win.h	(revision 351717f210df19b5dd8d203ad7fc30592d9516c6)
+++ Singular/sing_win.h	(revision 57aada1852e42727c6b0903d65418eddb4abee45)
@@ -2,5 +2,5 @@
 #define SING_WIN_H
 
-#ifdef ix86_Win
+#ifdef __CYGWIN__
 
 void heOpenWinHtmlHelp(const char* keyw, char* helppath );
@@ -8,4 +8,4 @@
 void heOpenWinntUrl(const char* url, int local);
 
-#endif /*ix86_Win */
+#endif /*__CYGWIN__ */
 #endif /* SING_WIN_H */
Index: kernel/oswrapper/feread.cc
===================================================================
--- kernel/oswrapper/feread.cc	(revision 351717f210df19b5dd8d203ad7fc30592d9516c6)
+++ kernel/oswrapper/feread.cc	(revision 57aada1852e42727c6b0903d65418eddb4abee45)
@@ -14,5 +14,5 @@
 
 //----------------------------------------
-#ifdef ix86_Win
+#ifdef __CYGWIN__
 #define READLINE_STATIC
 #endif
Index: kernel/oswrapper/fereadl.c
===================================================================
--- kernel/oswrapper/fereadl.c	(revision 351717f210df19b5dd8d203ad7fc30592d9516c6)
+++ kernel/oswrapper/fereadl.c	(revision 57aada1852e42727c6b0903d65418eddb4abee45)
@@ -190,5 +190,5 @@
     else
     {
-      #ifndef ix86_Win
+      #ifndef __CYGWIN__
       extern char *BC;
       extern char *UP;
Index: kernel/spectrum/semic.cc
===================================================================
--- kernel/spectrum/semic.cc	(revision 351717f210df19b5dd8d203ad7fc30592d9516c6)
+++ kernel/spectrum/semic.cc	(revision 57aada1852e42727c6b0903d65418eddb4abee45)
@@ -24,8 +24,4 @@
 
 #include <string.h>
-
-#ifndef ix86_Win
-//#include<values.h>
-#endif
 
 #include <misc/intvec.h>
Index: resources/feFopen.cc
===================================================================
--- resources/feFopen.cc	(revision 351717f210df19b5dd8d203ad7fc30592d9516c6)
+++ resources/feFopen.cc	(revision 57aada1852e42727c6b0903d65418eddb4abee45)
@@ -53,5 +53,5 @@
     {
       const char* home = getenv("HOME");
-#ifdef ix86_Win
+#ifdef __CUGWIN__
       if ((home==NULL)||(!access(home,X_OK)))
         home = getenv("SINGHOME");
@@ -166,5 +166,5 @@
 FILE* myfopen(const char *path, const char *mode)
 {
-#if (defined(CYGWIN) || defined(ix86_Win))
+#if (defined(__CUGWIN__))
   char mmode[4];
   int i;
Index: resources/feResource.cc
===================================================================
--- resources/feResource.cc	(revision 351717f210df19b5dd8d203ad7fc30592d9516c6)
+++ resources/feResource.cc	(revision 57aada1852e42727c6b0903d65418eddb4abee45)
@@ -87,5 +87,5 @@
   {"IdxFile",   'x',    feResFile,  "SINGULAR_IDX_FILE",    "%D/doc/singular.idx",  (char *)""},
   {"HtmlDir",   'h',    feResDir,   "SINGULAR_HTML_DIR",    "%D/singular/html",              (char *)""},
-#ifdef ix86_Win
+#ifdef __CYGWIN__
   {"HtmlHelpFile",'C',  feResFile,  "SINGULAR_CHM_FILE",    "%r/doc/Manual.chm",    (char *)""},
 #endif
@@ -100,5 +100,5 @@
   {"EmacsDir",  'e',    feResDir,   "ESINGULAR_EMACS_DIR",  "%D/singular/emacs",             (char *)""},
   {"SingularXterm",'M', feResBinary,"TSINGULAR_SINGULAR",   "%b/Singular",          (char *)""},
-#ifdef ix86_Win
+#ifdef __CYGWIN__
   {"rxvt",      'X',    feResBinary,"RXVT",                 "%b/rxvt",              (char *)""},
 #else
@@ -130,5 +130,5 @@
 static void mystrcpy(char* d, char* s);
 static char* feSprintf(char* s, const char* fmt, int warn = -1);
-#if defined(ix86_Win) && defined(__GNUC__)
+#if defined(__CYGWIN__) && defined(__GNUC__)
 // utility function of Cygwin32:
 extern "C" int cygwin32_posix_path_list_p (const char *path);
@@ -167,5 +167,5 @@
 void feInitResources(const char* argv0)
 {
-#if defined(ix86_Win) && defined(__GNUC__)
+#if defined(__CYGWIN__) && defined(__GNUC__)
   if (cygwin32_posix_path_list_p (getenv("PATH")))
     fePathSep = ':';
@@ -407,5 +407,5 @@
     return NULL;
   }
-#ifdef ix86_Win // stupid WINNT sometimes gives you argv[0] within ""
+#ifdef __CYGWIN__ // stupid WINNT sometimes gives you argv[0] within ""
   if (*feArgv0 == '"')
   {
@@ -471,5 +471,5 @@
       printf("Clean value:%s\n", value);
 #endif
-#ifdef ix86_Win
+#ifdef __CYGWIN__
 #ifdef RESOURCE_DEBUG
       printf("Clean WINNT value:%s\n", value);
Index: resources/feResource.h
===================================================================
--- resources/feResource.h	(revision 351717f210df19b5dd8d203ad7fc30592d9516c6)
+++ resources/feResource.h	(revision 57aada1852e42727c6b0903d65418eddb4abee45)
@@ -57,5 +57,5 @@
 const char fePathSep =
 /* not really cygwin, applies to all windows systems:*/
-#if (defined(CYGWIN) || defined(ix86_Win))
+#if (defined(__CYGWIN__))
                 ';'
 #else