Index: Tst/Plural/dmod_lib.res.gz.uu
===================================================================
--- Tst/Plural/dmod_lib.res.gz.uu	(revision 151609adec09397e40bc7601305d1dd6b3476999)
+++ Tst/Plural/dmod_lib.res.gz.uu	(revision 58b1160c31f60cc5b14e49848a7528f1889a1ba5)
@@ -1,72 +1,77 @@
 begin 640 dmod_lib.res.gz
-M'XL("%@OGDL``V1M;V1?;&EB+G)E<P#M&^]OVSKN>_X*H;@/3AROEN2D[8H4
-M6)?MO0#M-C0[W#L<FL%IG=9XCMUGNUN<P_WO1U*R+3M>V[W]P#YLPQ*)HDB*
-MI"A2RN;OI[,WC#%^PLYFIVPOS_)G4;C<.^[-]8@X80#\$,9A;O6/>_C-3D[8
-M]3JY_@"8S^+@T[,L]_-J@B12>XC0(N6=L/U]EM['S(\B%FS\]5T49-7PZ!E\
-M[)V_@,Z[B[<O7TW_>?%J_ASFMT'5C/$)?&@ZS(_C57;<`PYW:7*ENFR5)FL&
-M4K!2G-ZK/UZ<OSM[];S'6!K&-RQE$^8.K<VP&&[[P^G=,0S<)5'!7L/`=K!9
-M"+M82(1>!ROV@@&42%NO^\>XG-L@#88LOPUPW+^/<G9Z#NN[2=(POUVS3R$L
-M=1FP^RRX!AI9D!/7%S079_TK*"+$#Y:IS\*8*4F&T\UP6@RGVSY,.ILB-B(#
-MY_`VC/P\25FR8J\7_W7X_UCR,4C9B][9]#_\<E(,IH4M!]O!=&M+A(G+R68P
-MW3B"8`B1`%D(P'/DH,`&0;W+B>XB[@:Q"X2/@.9"(CF<M-4-'!E?3DI$T-+1
-MH,#FAAA#>[I!G(/+23E`G&QOL"7>JJ<08;;09'#.X>6DPD+&CCA0746BQI;.
-MR*M).V-J@<).YZ3>-$GR#"R0W[(U&":\B\*K,`^##'5W.B<SQ\DZ]*,>:`X]
-M@GU`%3I<-4%SCK<O50>4YHS*CD>=L>J`@IP#Z``^T>!#_;=7.>K!CJ.Z+4]U
-MO]95-PN)CFIOE;/>P8P\"CX&$4ZJW7?"YL3O])P<V/1(P`&1_"@/TMC/0YA:
-M#%D2!^S*C]%_]<RW[QEXGVJ?O7VO_%,[GS*:4SN5T+"-LZE@$AVJAA7:^=!)
-M;?)>]#%PS<Q<7KCV[ZQT"#+KI9Q6.]&USJ9#6DRYEM/CAE1-RO;8%,P45G8(
-MZW4(.\+]0SM";XRM^AJCE^J-00B%0L`OO7/&N,.4A[9\3CS%YWC+R43M8H>F
-MB\U;P7#^3:+A$UVL\K&O#9'?T[4JO1WMZBU*;MJJ`]`7:6]7=YY=C.S-H/">
-MI#K@9RE?;ZF#HSXX*L0;T!HW]@AB,$91"*;4*"#&%DI;?`R@S!$NP#.:"%HC
-MH%(384IL<*%:,$>4!!W-HBA9P*#KEK3'BDMFCUQ%OE0I=TV5+B&:9'D0QJ?G
-MM5(-X!<ZY?#3`VXI!I^ZM6OP([5^-MR+>N/)?6$&>VD&>]T9Z\A/G0.DQ+O.
-M@<99P+FIG>0N2/$T-Y53PW[8F5"S[/*ZUU6R`COV)HS]R#@Z69AG0;3J&;RJ
-ME(7=!'&0AE=FWM(9DVE+?I^H#*1Q>O9@7-:)4$:2NR1Z4V3W,^>(VR6RVR6S
-MVR6T^^A9XC[A,%EF)'&<I&L_"K?!-3LM_9T,U<L6(_M@D"T\FQ_(_2-H25M(
-MU1(V'WG8LCUW_ZB=//GQ=4?NA*[08O%-#C/&WLUK7],^.639L_P9C`P@W<UL
-MR'<GL&+H9`PV!=BK)_8/>9ECHH8H9:Q@Q<)#@$>`.O6$Y-'`08!G:T!))BLQ
-MB$:FADLN6P)@9EJFJ26@T/1D26!+U(UA1=^IL(FU(J6=H4D9PFXI2"FY&D:A
-M.;9I'AD33$FSJLY6=T8UGLW5I,+L$)XMB!.BV8<ECLW'!%1;.PVN[Z\""^WA
-M++/AV50=\E>WP=6?9#@(8F"ZO$!/>3?ON77H$SMI\%UP!3&DE0LKX!>>M]>M
-MT">=0I0A#I)%LVIKYHGK,)[%^06XNW4Z!^\=NA`!Z4P`H>:)2EP`"3)0"'9Q
-M'MQ`M86[@X49([R27%KQ:^?9[8BZ*Z:Q<$IGAPX?RGVOWPBCR+7W01_^&(S&
-MZE0^ZM%>D^5Q+53Y17N.'^JS>R&<0UUM.1)3!8A`M!&Y>UAN#&E+H1W4$7RL
-MYT&LX(C=+:4C4*4@9:F;Y7W.LAR3NEVYA9);JCR%BP<$/ZKE]LHJL2$W;IY2
-M;+TR"&N>+*7VQ-'GI>94_(#4P>8JN,O#!$^U6LZI9B-:(CMC)1PR55)H$0E[
-M1$M1W*D4I11A=W4'R`"5K4K>#UCQEBM4"ZRVC-S9,N_\U%^;^8()?>*FL=RA
-M/USV/Y.J+@1SF%4X?G\`G\O^P[F#R;ZYO5H9O%J^3?HL;,OQ@;2^)1#5C82R
-MJ&WY-@P6I=8R1!\@>C4QT[E!E09[9?9K.6+@PS]`0DX.;@`@X(.58&"PM)<+
-M08SAN$&QCWOTA2):2+J]HTDQOZ%BA$-:60AU2*4%Q0;3@S[ZT3WDO!,?@]\=
-MD@V@G,ZJFK6EKM]`79\I6DE7I:9,/55)B(+#,5+IHJ5#6&U;A[1RK:(^Y3MM
-M%1CAVMOQO=/S6<OO`/*W"J/P.@!UD;M!Z@HK>H*3`:_NHFBGT'<RB_?A0^"'
-M[%>J*\K\"5#`*7"\J+\48E5#UJK$.T!*")`J&H;FJ/U<S2>H[)>8LD]"#+00
-M`KR&OLHAT>^Z!L`I=EV/$!M>Y4]$GU<9%"$3"@V(JD)I#=352FO`ZZI5:ON/
-M3/O3^8ZG9.T`%>AA#ZBM.B&;/EHJ0U)3+*A87E"U7/&Q7@\Q67$I=N,6=*B+
-M![&OCF38=<M5CS=V[:!H$OD-5KGG1S=B3YVN#F\1N-FY,RR8Z-5W+9SNG??F
-MKUZ^?3-]<?%O-G7.WTY;E]8/C%9T=J\%=^+ZUQ>!C3OL1W?8PQOLU^5RU]7=
-MM[XNYH<[?G'V]GW+,0#R0SRC=`W@]\LW?@+?.-KQC1W7^'K/T'YA;Q>CI_C&
-M8Z[!1RJ'YJXZ@<?:2USM)@WS*^.#CD;Z1M)6PS1E5.;2?#301O,0$^OKEEN-
-M*KBFN]6N`XM2I+9TT%0>!@B/6%#R?9"YOB$\J+IH1:\>13MZLNKB/:%7(^--
-MH7=4=0_1`VKD(^S2:.=%8L,;A+M[>VT>(?-O=(;\K<>E'WZ7+_BN-AJ!<_ZM
-M(N>7OH0\&CR_ET;$KD9V%?+C]?&8.G[2V^%*K;M5^:_WW%_ON=_R/5=XG<47
-M[ZB^^%>^3+;+K<=<[<$+S89=:Q'5O9NLBC<LNV19N\50=QGE5]9S.^;RQMRN
-MNB_K&0=C=^TJ.M0GOGJG8IKYG10G].*-BK>]ZHYB5?9D%Y%]J6]J'6@V%6_<
-MTHOQCNI>^U=YDK9TIX`_M^\I&=7RA3O(;*DU^50'W"'`30*?\\*.R58Y>R'Z
-MU1-7PV@PN2;(38/0-<'>*DEODARO%G2K&H=RL3)7$G^,DBO#5`KPQ3YN3>\L
-M@:\J%N^3/J,PR]D9X"`R=JRTAK\!N.9DG54A/<TTNO6F8;4THVL@]?L4U)6?
-M@J:"%"B%5^PY<Q4\OE\O`_J=VT<?2#T'MR8X_5D"JS\Q;@(\2:\#(CS-#(SZ
-MSW,6^^L@P^:&%1U$A$GD^E$BVPX2TB3QLK;=46V;^J&I-D\->Y*%F/G@E57.
-MO^),QR$+#L9^?;\ZX_A86K[46BO>A[-)/6\S$!PP6L^X#*8<]V;T`Q,ZMV;T
-MDQ$XJ*"!QY>@X\MX,YOQ^L&,A&$KP=1E>2$-20AHB")(%&0(07DFB"&6OM#4
-M#(4^+\<MAJ+Q0A<GG]BG@(51=)_EJ9\'M+.6P:W_,4SNR7U6M`_#;:!FY,E-
-M`#BI"IP^NXF2)4A86J_2ME#:WIA/BRM)-CA"18,J^OC-Z=.CZ+J_KZDM'>,G
-M$B@#GU3VJ94B@58EG;62&.A1):"XF:14Q^;8PAH9&&)34M-KZ43-+'6"K_8^
-M6R=I0(]R:0`;"U:4A?F]CP\5Y1)9QAJ;WG`IMB(C2F:S`C^VIBU;IJPL"5+K
-MW&=&1L1<9T96)%?2*4]3<F7,.O&1;KUCPNSW)$I0B49$,X!/V#,7#SP1F_ME
-MYQJ4Y'I"@5)?=1F/"S8^<Q6-Y+CQFB#*WU?18P6FBL:J+'Q2IU.D5/>$9?FU
-M19S[IJ)-*9HD9H!7GR"2USI-@W"U"N):GQKPL"XIG&,T5\B6-QPU0SIV+EX>
-M]S:%^J&;5S,7-7,_3?WX)C!J)05X@B'_,'\$EC>,^1?:31&R)(E5[ZF_:&-0
-M2KY1[[F%>L$%Q:D'W*UZN-W86_5<6U#C@#"@62U#GOQ*BGZ>I$AZZO\EX'\]
-1N,=GK>-_]/X/X"2D.\TP````
+M'XL("&-I'4X``V1M;V1?;&EB+G)E<P#M6U]OVS@2?_>G(()[D"VK$4G921HD
+M0%.WW0!)6]0]W!X.=2$[<B*L+'DEI;%\N.]^,T-*HF3E3[?MH@_=Q3KD<#@<
+M_F8X')+:Z<?)^5O&&#]E%^=G;"_/\F=1.-\[[DUUBSAE0/P<QF%N]8][^)>=
+MGK*K57+U&3B?Q<'=LRSW\ZJ#)%%[R-`2Y9VR_7V6WL;,CR(6;/S5.@JRJGGT
+M#'[V+E]`Y?V'=R]?3?[YX=7T.?1ODZH>XU/XT7*8'\?+[+@'(ZS39*&J;)DF
+M*P9:L%*=WJO?7UR^OWCUO,=8&L;7+&4GS!U:FV$QW/:'D_4Q-*R3J&"OH6$[
+MV,R$7<PD4J^")7O!@$JBK=?]8YS.39`&0Y;?!-CNWT8Y.[N$^5TG:9C?K-A=
+M"%.=!^PV"ZY`1A;D-.H+ZHN]_A44$?('\]1G8<R4)L/)9C@IAI-M'SI=3)`;
+MF6'D\":,_#Q)6;)DKV?_=?C_6/(E2-F+WL7D/_S323&8%+8<;`>3K2V1)CZ=
+M;`:3C2.(AA0)E)D`/D<."BP0U?MTHJO(NT'N`NDCD#F3*`X[;74!6\:?3DI&
+M0.EH4&!Q0P-#>;)!GH-/)V4#C61[@RV-K6J*$7H++0;[''XZJ;AP8$<<J*H2
+M47-+9^35HITQE0"PLRG!FR9)GH$%\ANV`L.$ZRA<A'D89(C=V93,'">KT(]Z
+M@!QZ!/N,$#I<%0$YQ]N7J@*@.:.RXE%EK"H`D',`%>`G&7RH_^U5CGJPXZAN
+MRU/=;W75S4RBH]I;Y:QKZ)%'P9<@PDZU^YZP*8UW=DD.;'HD\(!*?I0':>SG
+M(70MABR)`[;P8_1?W?/=1P;>I\H7[SXJ_]3.IXSFU$XE-&WC;"J:1(>J:85V
+M/G12F[P7?0Q<,S.G%Z[\M94.06<]E;-J);K6Q61(DRGG<G;<T*HIV1Z;BIG*
+MR@YEO0YE1[A^:$7HA;%5?\;HI7IA$$.A&/"/7CEC7&'*0UL^)Y[B<[SE9*)V
+ML4/3Q::M8#C]+M'PB2Y6^=BWAL@?Z5H5;D>[N$7)=1LZ('T5>KO8>78QLC>#
+MPGL2=#">I7R]!0='/#@"X@UHCAM[!#$8HR@$4RH4$&,+A18?`RESA`OTC#H"
+M:D14,!&GQ`(7J@1]1"G0T4,4Y1#0Z+JE[+$:);-'KA)?0LI=$](Y1),L#\+X
+M[+(&U2!^I5,.[QYP2S&XZT;7&(]@O3?<BWKAR7UA!GMI!GM=&>O(3Y4#E,2[
+M]H'&7L"YB4ZR#E+<S4UP:MK?MB?40W9YW>LJ68$5>QW&?F1LG2S,LR!:]HRQ
+MJI2%70=QD(8+,V_IC,FT)'],5`;1V#U[,"[K1"@CS5U2O:FR>\\^XG:I[';I
+M['8I[3ZZE[A/V$SF&6D<)^G*C\)M<,7.2G\G0_6RV<@^&&0SS^8'<O\(2M(6
+M4I6$S4<>EFS/W3]J)T]^?-61.Z$KM(;X+IL98^^GM:]IGQRR[%G^#%H&D.YF
+M-N2[)S!CJ&0,%@78JR?V#WF98R)"E#)6M&+F(<$C0IUZ0O)H\"#!LS6A%).5
+M'"0C4\WE*%LB8&9:IJDEH=#R9"E@2]*-9B7?J;AI:"5*.T-3,H3=4I%2<]6,
+M2G,L4S\R)IB2>E65K:Z,:CZ;JTZ%62$^6]!(R&8?ECPV'Q-1+>TTN+I=!!;:
+MPYEGPXN)VN07-\'B#S(<!#$P75Z@I[R?]MPZ](F=-'@=+""&M')A1?S*_?:J
+M%?JD4X@RQ$&R:)[:FGGB*HS/X_P#N+MU-@7O';H0`6E/`*6FB4I<@`DR4`AV
+M<1Y<PVD+5P<+,T9\I;BT&J^=9[<CZJZ:QL0IG1TZ?"CWO7XCC.*HO<]Z\\=@
+M-%:[\E&/UIHLMVNACE^TYOBAWKMGPCG4IRU'8JH`$8@6(G</RX4A;2FT@SJ"
+MCW4_B!4<N;NU=`1""EJ6V,QO<Y;EF-3MZBV4WE+E*5P\H/A1K;=7GA(;>N/B
+M*=76,X.PYLE2:T\<W:\UI\,/:!UL%L$Z#Q/<U6H])WH8T5+9&2OE<%"EA5:1
+MN$<T%34Z'44I1=B=W0$.@&"K(^]G//&6,U03K):,W%DR[_W47YGY@DE]XJ*Q
+MW*$_G/?O255G@CG,*AR_/X#?>?_AW,$<OKF\6AF\FKY->!:VY?@@6M\2B.I&
+M0EG4MGP;&HL2M0S9!\A>=<QT;E"EP5Z9_5J.&/CP'S#A2`XN`!#@@Y6@83"W
+MYS-!`\-V@VH?]^@/JFBAZ/:*)F#>(##"(51F0FU2:4&QP?2@+WYT"SGOB8_!
+M;XUB`SA.9]69M077&X#KGD,K854B9>)4)2&*#MM(A44+0YAM&T.:N8:H3_E.
+M&P(C7'L[OG=V>=[R.Z#\I8-1>!4`7.1ND+K"C+J=#,8:\`&+@AR.AVR1K-:W
+M>:#R#R6B[8B@C[[8V''#W:RND=0YF<7[\"/P1_8KN(LRYP(6<"1L+^H_BK$Z
+M=];PX[TA)1$H%8U)?50,J/H35?9+3MDG)09:"0&>1G_*)M&O\[,J_W*F,!L-
+M1B,+0U%V?;:AX7F5B]&XO,K&B)E8J$%4IYU60WWR:35X7><>;4$Q@.3T;M@V
+MXYDS#:]7?F7(G7U4-9N6';H0O(U%0QR5ZU@K'\@;*PK\*XCT_;Y.36`\?Y&S
+M)23(N"ZQ&3KWT/1#9>!A93ZE,J26ZGBC+TU:EZ_WFJ$QI>=P-L(D`75;A&L_
+M&K(."YF@5Q`J+;*$+4'Q).U,Q/TT@&0LOTUCNC=!H.6`&+O!#O6B:R#-RM`4
+MMG&6?9V*^S2)UQ1@[`++N?]'$!MBSL('3<!^M!$H'GR6]Z)>X]C&7S97R'WF
+M*#WY,2M4H7-DADY*C3'!K&-G17HX>-8!\83"X:.W3'`>*&9TSS2CBZ9J'#`I
+MYOFN"HV@AD-5!,I7V2S89+[L\<:&-RB:0M[`HM[SHVNQIYS#X2T!USO7[043
+MO?J:DM.3S=[TU<MW;R<O/OR;39S+=Y/6>\\#K96<W1OUG93HV^]/&L\_CV1`
+MW8E^8S__]2ZS<^O]O5]:^.&.7UR\^]AR#*#\+9Y1N@:,]\LW?@+?.-KQC1W7
+M^';/T'YA;V>CI_C&8Z[!1^KXR5V5B(ZUE[C:31KF5\8'C$;Z,M]6S=1E5!Y#
+M^6B@C>8A)UY-M=QJ5-&UW*UV'9B4$K6EC:;R,&!XQ(*2[X/.]>7Z055%*WIU
+M*]K1DU45K]B]FADOV;VCJGJ('E`S'V&56COOX!O>(-S=AQ]S"YE^ISWD+[W+
+MWN\//^@93/!=-!J!<_J](N?7/B(^&CQ_%")B%Y%=0/Y^/!Z#XR=]6*E@W;W0
+M^O4IQ*]/(;[GIQ#"ZSQ\\8[3%__&1_WV<>LQ5WOP+:!AUUI%=64MJ\,;'KMD
+M>7:+X=QE'+^RGMO1ES?Z=IW[LIZQ,7:?744'?.*;5RJFF3\(.*$G;YQXV[/N
+M.*S*GNP2LB_U(X<#Q2;PQ@.7&.]`]YKN'5K8*>+/[7M*1S5]X0XR6VHDG^J`
+M.P*X*>`^+^SH;)6]9Z)?7?<TC`:=:X'<-`A=$^PMD_0ZR?%J09>J=C@N5N9*
+MXB]1LC!,I0A?[>/69&T)?)"T>)_PC,(L9Q?`@\Q8L=*:_A;H>B3KH@KI::;9
+MK;<-JZ4970.I3[L0*S\%I((4)(4+]IRYBA[?KN8!?2+ZQ0=1S\&MB4[_S&&H
+M/S!N`CU)KP(2/,D,COJ?YRSV5T&&Q0TK.H0(4\C5HT*V'2*D*>)E;;NCVC;U
+M&VUMGIKV)`LQ\ZTXJYQ_R9F.0Q9LC/WZ:>*<XW<&Y>VNM>1]V)O4&P(#Q8&C
+M]04$@R['O7/Z-HOVK7/ZV@HV*BC@]B5H^S*>F\]Y_=9,RK"E8.J=J9"&)D0T
+M5!&D"@X(0?E<T(!X](6B'E#H_7+<&E`T'K?CY([=!2R,HMLL3WW]L#(/;OPO
+M87)+[J.N3<-MH'KDR74`/*D*G#Z[CI(Y:%A:KT);*+0WYJO\4I(-CA!H@**/
+M?SG]>OOJKEE+FSO&UT6H`S^I[%.#(D%6I9VUE!CH$1(`[EQ2JF-S+.$9&0;$
+MHJ2BU\)$]72,&UZ?K9(TH/?L-("%!3/*POS6QS>^<HHL8XU%;[@46Y(1);-9
+M@3];TY8M4U:6!*UU[G-.1L1<YYRL2*ZD4YZFYLJ8=>(CW7K%A-EO2437YT9$
+M,XA/6#,?'OBZPEPO.]>@I-<3#BCU59?QQF;C"W'12(X;CVJB_#21WNPP531F
+MA2\.Q[2+E'"?L"S'AP@8N6\";6K1%'$.?/4.(GF-:1J$RV40UWAJPL-84CC'
+M:*Z8+6\X:H9TK'QX>=S;%.H;4:\>7-2#^VGJQ]>!<592A"<8\G?S^\F\8<P_
+MT6Y*D"5)K7I-_4D+@U+RC?H4HE`?/P!PZMN'K?KF86-OU9<.!14.B`.*U33D
+@Z:^DZ.=)BJ2G_I<>_+]V;O'-Z_@?O?\#)\JQA@@T````
 `
 end